/***************************************************************************************

		Treiber fr Canon BJ200 Drucker fr Atari DVI-Treiber (Version 2.30):
		Fr Quer- und Hochkant!

		- DVI-Druckertreiber fr Canon BJ200 Drucker. Der Sourcecode entspricht
			(immer noch) grtenteils der EPSON-Stylus Version. 

		- WICHTIG: Dieser Treiber erwartet, dass der Canon BJ in der
											____BJ-Emulation____
			betrieben wird! Fr die EPSON-Emulation kann man den EPSON LQ800
			Treiber benutzen. Letzterer bietet nur keine echten 360*360 dpi
			Auflsung (Eine Nadel wird in der EPSON-Emulation immer durch zwei
			Dsen emuliert) und auch keinen 48 Dsen Druck :-(.

		- Bemerkung: Ich habe diesen Treiber nur teilweise getestet!
								 (Nicht nur) Deshalb:

			BENUTZUNG AUF EIGENE GEFAHR. ICH BERNEHME KEINE VERANTWORTUNG
			FR EVENTUELLE SCHDEN, DIE DURCH DIE BENUTZUNG DIESES TREIBERS
			VERURSACHT WURDEN. ICH BEHAUPTE AUCH NICHT, DASS DIESES PROGRAMM
			IRGENDEINEN ZWECK ERFLLT.
			WER HIERMIT NICHT EINVERSTANDEN IST, DARF DIESEN TREIBER NICHT
			BENUTZEN!!

			Verbesserungsvorschlge sind willkommen:

			Derzeitige Adresse:
			
			Dietmar Herrendrfer,
			Department of Physics,
			Trinity College,
			Dublin 2
			Ireland
			email: dhrrndrf@tcd.ie
			
		- Version 1.2

		 1995, Dietmar Herrendrfer.
		 Markus Pristovsek, fr die Teile, die aus anderen Treibern wurden.
		
		Bem.: Tabulatorabstand auf 4 Zeichen setzen.
*/

/* Weitere Bemerkung: Der Treiber wurde von mir (Markus Pristovsek) in neue Form 
eingepat. Theoretisch sollte er funktionieren, kann jedoch von mir mangels Drucker 
nicht getestet werden. Dabei wurde Header und Haupdatei getrennt! (48DUESEN.C) */

#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include "portab.h"
#include "treiber.h"



/*** Ein paar Parameter: ***/
/*++ Seitenabmessungen - alle Pixelgren bezogen auf 360dpi*360dpi: ++*/
#define TOP 				43L 														/* Oberer Rand in Pixeln. */
#define BOTTOM			90L 														/* Unterer Rand in Pixeln. */
#define LEFT				47L 														/* Linker Rand in Pixeln. */
#define RIGHT 			49L 														/* Rechter Rand in Pixel. */
#define A4WIDTH 		2976L 													/* A4 Papierbreite in Pixeln. */
#define A4HEIGHT		4209L 													/* A4 Papierhhe in Pixeln. */
#define WIDTH 			(A4WIDTH-LEFT-RIGHT)						/* max. Breite einer Grafikseite */
#define HEIGHT			(A4HEIGHT-TOP-BOTTOM) 					/* max. Bitmap Hhe */
#define BUF_SIZE		WIDTH*6L+6L+256L								/* Gre des bentigten Zeilenpuffers. */

/*** Neudefinierte Typen: ***/
typedef struct {
	UBYTE 	id; 												/* Druckmodusnummer. */
	WORD		h_dpi;											/* Horizontale Auflsung. */
	WORD		v_dpi;											/* Vertikale Auflsung. */
	WORD		bytes;											/* Bytes pro Druckkopf-Spalte. */
} MODI;

/*** Lokale Variablen: ***/
/*++ Drucker Steuercodes und hnliches Druckerspezifisches: ++*/
static UBYTE		init[]		= "\20\033[K\002\000\000\045"/* Reset & 1/360 dpi spacing. */
														"\033[\\\004\000\000\000\150\001";
static UBYTE		h_step[]	= "\4\033d__";							/* Horizontale Druckkopfbewegung. */
#define H_POS 120L																		/* Horizontale Positioniergenauigkeit */
#define PIXELVALUE	3L																	/* Auf ein Pixel genau */
static UBYTE		v_step[]	= "\6\034CJ\004_\015";			/* Zeilenvorschub in 360 dpi. */
static UBYTE		v_skip[]	= "\6\034CJ\000\200\015"; 	/* 256/360 Inch Zeilenvorschub. */
static UBYTE		g_print[] = "\6\033[g___";						/* Bitmap-Graphik drucken. */
#define MODE_BYTE 5
static MODI 		cbj_mode[]= {{	0,	60,  60, 1},		/* Canon BJ200 Druckermodi: */
														 {	1, 120,  60, 1},
														 {	2, 120,  60, 1},
														 {	3, 240,  60, 1},
														 {	8,	60, 180, 3},
														 {	9, 120, 180, 3},
														 { 11, 180, 180, 3},
														 { 12, 360, 180, 3},
														 { 13, 120, 360, 6},
														 { 14, 180, 360, 6},
														 { 15, 240, 360, 6},
														 { 16, 360, 360, 6},
														 {	0,	 0, 	0, 0}}; 	/* Markiert das Listenende !*/

/****************************************************************************************/

#include "48Duesen.C"