/***************************************************************************************

		Treiber fr Stylus800 Drucker fr Atari DVI-Treiber (Version 3.00):
		Fr Quer- und Hochkant!

		 1995, Dietmar Herrendrfer.
		 Markus Pristovsek, fr die Teile, die aus anderen Treibern stammen.

Weitere Bemerkung: Der Treiber wurde von mir (Markus Pristovsek) in die neue Form 
eingepat. Theoretisch sollte er funktionieren, kann jedoch von mir mangels Drucker 
nicht getestet werden. Dabei wurde Header und Haupdatei getrennt! (48DUESEN.C) */

#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include "portab.h"
#include "treiber.h"



/*** Ein paar Parameter: ***/
/*++ Seitenabmessungen - alle Pixelgren bezogen auf 360dpi*360dpi: ++*/
#define TOP 				0L 														/* Oberer Rand in Pixeln. */
#define BOTTOM			0L 														/* Unterer Rand in Pixeln. */
#define LEFT				0L 														/* Linker Rand in Pixeln. */
#define RIGHT 			0L 														/* Rechter Rand in Pixel. */
#define A4WIDTH 		2880L													/* A4 Papierbreite in Pixeln. */
#define A4HEIGHT		4080L 												/* A4 Papierhhe in Pixeln. */
#define WIDTH 			(A4WIDTH-LEFT-RIGHT)					/* max. Breite einer Grafikseite */
#define HEIGHT			(A4HEIGHT-TOP-BOTTOM) 				/* max. Bitmap Hhe */
#define BUF_SIZE		WIDTH*6L+6L+256L							/* Gre des bentigten Zeilenpuffers. */

/*** Neudefinierte Typen: ***/
typedef struct {
	UBYTE 	id; 												/* Druckmodusnummer. */
	WORD		h_dpi;											/* Horizontale Auflsung. */
	WORD		v_dpi;											/* Vertikale Auflsung. */
	WORD		bytes;											/* Bytes pro Druckkopf-Spalte. */
} MODI;

/*** Lokale Variablen: ***/
/*++ Drucker Steuercodes und hnliches Druckerspezifisches: ++*/
static UBYTE		init[]		= "\26\033@\033x\001\033(U\001\000\012\033$\000\000\033(V\002\000\000\000";
														/* Reset & 1/360 dpi spacing. */
static UBYTE		h_step[]	= "\4\033\\__";									/* Horizontale Druckkopfbewegung. */
#define H_POS 360L																				/* Horizontale Positioniergenauigkeit */
#define PIXELVALUE	1L																			/* Auf ein Pixel genau */
static UBYTE		v_step[]	= "\6\033(v\002\000__";					/* Zeilenvorschub in 360 dpi. */
static UBYTE		v_skip[]	= "\6\033(v\002\000\000\001"; 	/* 256/360 Inch Zeilenvorschub. */
static UBYTE		g_print[] = "\5\033*___";									/* Bitmap-Graphik drucken. */
#define MODE_BYTE 2																				/* Position Modusbyte! */
static MODI 		cbj_mode[]=
{
	{ 0, 60, 60, 1 },
	{ 4, 80, 60, 1 },
	{ 6, 90, 60, 1 },
	{ 1, 120, 60, 1 },	/*+*/
	{ 3, 240, 60, 1 },	/*+*/
	{ 32, 60, 180, 3 },
	{ 38, 90, 180, 3 },
	{ 33, 220, 180, 3 },
	{ 39, 180, 180, 3 },
	{ 40, 360, 180, 3 },	/*+*/
	{ 71, 180, 360, 6 },
	{ 73, 360, 360, 6 },
  {	0,	 0, 	0, 0} 	/* Markiert das Listenende !*/
};
/*+* heit: Kann keine nebeneinanderliegenden Punkte drucken! */

/****************************************************************************************/

#include "48Duesen.C"