/******************************************************
****									 VDI.C											 ****
**** VDI-Treiber, gibt (Teil-)Seite ueber GDOS aus ****
******************************************************/

/* Geaendert von Thomas Wieschebrink am 23.7.95 	 */
/* Neu an DVI 3.00 angepasst 7.10.95 m. Pristovsek */
/* Nochmal korrigiert von TW am 5.11.95 					 */
/* Option: "Drucken in Datei" und "anderes Gert"  */
/* eingebaut (5.5.96)                              */

#include <vdi.h>
#include <tos.h>

#include <stdlib.h>

#define FALSE 0
#define TRUE 1

#define NO_VDI FALSE	/* TRUE: eigene	Deklarationen	verwenden	*/

/********************************************************************/

long	max_puffer_laenge	=	0;

#if NO_VDI

/* VDI */
typedef struct
{
	int	 *contrl;		 /* Zeiger auf contrl-Array */
	int	 *intin;		 /* Zeiger auf intin-Array	*/
	int	 *ptsin;		 /* Zeiger auf ptsin-Array	*/
	int	 *intout;		 /* Zeiger auf intout-Array */
	int	 *ptsout;		 /* Zeiger auf ptsout-Array */
} VDIPB;

extern void vdi( VDIPB * ); /* Als Assembleroutine */

#endif

/* Neue Routine wegen erweiterter Parameteruebergabe */
void vq2_extnd( int handle, int owflag, int *work_out, int weite, int hoehe )
{
/* ACHTUNG: 																						 */
/* Funktioniert SO nur mit PC 1.1!											 */
/* Aeltere Versionen brauchen eine andere Behandlung! 	 */
/* Die Funktion "vdi()" und die Definition der					 */
/* Parameterbloecke ist sehr stark Bibliotheksabhaengig! */

	VDIPB	 vdipb;

#if NO_VDI	/* Fuer	Version	1.0	*/
	int		 contrl[15];
	int		 intin[4];
	int		 ptsin[4];

	vdipb.contrl = contrl;
	vdipb.intin	 = intin;
	vdipb.ptsin	 = ptsin;
#else
	vdipb.contrl = _VDIParBlk.contrl;
	vdipb.intin	 = _VDIParBlk.intin;
	vdipb.ptsin	 = _VDIParBlk.ptsin;
#endif
	vdipb.intout = work_out;
	vdipb.ptsout = &(work_out[45]);

	vdipb.intin[0] = owflag;

	vdipb.contrl[0]	=	102;
	vdipb.contrl[1]	=	0;
	/* Sollen	die	Seitenmasse	geaendert	werden?	*/
	if(	 weite>0	&&	hoehe>0  )
	{
		vdipb.ptsin[0] = weite;
		vdipb.ptsin[1] = hoehe;
		vdipb.contrl[1] = 1;
	}
	vdipb.contrl[3]	=	1;
	vdipb.contrl[6]	=	handle;

	vdi( &vdipb	);
}
/* 29.10.95 TW */


/********************************************************************/
/* Schreibe in DVI-Datei */

int drucke( char *p, long start_x, long weite, long hoehe, long h_dpi, long v_dpi,
						short fh, short flag, short quer, char *optionen )
{
/* Es werden auch gesplittete Seiten korrekt ausgedruckt!!! 							 *
 * Mit NVDI ab Version 3.02 waere auch das Drucken in eine Datei moeglich, *
 * dafuer muesste allerdings der gesamte Dateiname in 'v_opnwk' uebergeben *
 * werden, nicht nur ein File-Handle! 																		 *
 * Ab NVDI3 kann auch quer (und gesplittet) gedruckt werden, einstellbar	 *
 * im CPX-Modul!																													 *
 * Die DVI-Auflsung muss nun nicht mehr mit der Drucker-Aufloesung ueber- *
 * einstimmen.																														 */

	int				i, hdl, work_in[16], work_out[57], color_index[2];
	long			drucker_hdpi, drucker_vdpi, start_y;
	MFDB			bitmap, drucker;
	extern char	tmp_file[256];	/* Name Zieldatei */

	if(	 vq_gdos()==0	 )
	{
		Cconws( "Kein GDOS installiert!\7" );
		return -1;
	}

	/* Und nun die Ausgabe auf Geraet	21 oder	neue Unit	*/
	work_in[0] = atoi( optionen	);
	/* moegliche VDI-Handles */
	if(	 work_in[0]<11	||	work_in[0]>99  )
		work_in[0] = 21;
	for( i = 1;	i	<	10;	i++	)
		work_in[i] = 1;
	work_in[10]	=	2;
	work_in[11] = 0;	/* Defaultformat wird schon stimmen */
	if(  fh>5  )
		*(long *)(work_in+12) = tmp_file;
	else
		*(long *)(work_in+12) = 0L;
	work_in[14] = work_in[15] = 0;
	v_opnwk( work_in,	&hdl,	work_out );	/* Ist unzureichend! Contrl=16! */

	if(	 hdl<=0	 )
	{
		Cconws( "Gert lt sich nicht ffnen!\7" );
		return -1;
	}

	drucker_hdpi = (25400/work_out[3]);		/* Horizontale Auflsung in DPI */
	if(  labs(drucker_hdpi-h_dpi)<5  )
		drucker_hdpi = h_dpi;					/* Rundungsfehler ausgleichen */
	drucker_vdpi = (25400/work_out[4]);		/* vertikal genauso */
	if(  labs(drucker_vdpi-v_dpi)<5  )
		drucker_vdpi = v_dpi;

	if(	 flag&2	 )
	{
		bitmap.fd_addr			= p;
		bitmap.fd_w 				= (int)weite;
		bitmap.fd_h 				= (int)hoehe;
		bitmap.fd_wdwidth 	= ((int)weite+15)>>4;
		bitmap.fd_stand 		= 0;
		bitmap.fd_nplanes 	= 1;
		/* Setzen, weil nicht unbedingt mit '0' initialisiert */
		bitmap.fd_r1 = bitmap.fd_r2 = bitmap.fd_r3 = 0;

		/* Mae umrechen, oder wie soll das sonst gehen??? */
		weite = (weite*drucker_hdpi)/h_dpi;
		hoehe = (hoehe*drucker_vdpi)/v_dpi;

		/* Offsets anpassen */
		if(  !quer  )
		{
			start_y = start_x;
			start_x = 0;
		}
		start_x = (start_x*drucker_hdpi)/h_dpi;
		start_y = (start_y*drucker_vdpi)/v_dpi;

		/* Quell-Raster auf Drucker-Raster begrenzen, 			*
		 * sonst gibt es u.U. Pixel-Mll oder leere Seiten! */
		if( start_x+weite>work_out[0]+1 )
			weite = work_out[0]+1-start_x;
		if( start_y+hoehe>work_out[1]+1 )
			hoehe = work_out[1]+1-start_y;

		/* Drucker-Rastergre setzen */
		vq2_extnd( hdl, 0, work_out, (int)(start_x+weite-1), (int)(start_y+hoehe-1) );

		/* Adresse wird vom Treiber gesetzt!! */
		drucker.fd_addr 		= 0;
		/* Rastergre des Druckers bernehmen		*
		 * Breite bzw. Hoehe ist ein Pixel mehr!! */
		drucker.fd_w				= work_out[0]+1;
		drucker.fd_h				= work_out[1]+1;
		drucker.fd_wdwidth	= (work_out[0]+16)>>4;
		drucker.fd_stand		= 0;

		/* Farbebenen des Druckers feststellen (1 : erweiterte Parameter) */
		vq2_extnd( hdl, 1, work_out, 0, 0 );
		drucker.fd_nplanes	= work_out[4];
		drucker.fd_r1 = drucker.fd_r2 = drucker.fd_r3 = 0;

		/* work_in als pxyarray missbrauchen */
		work_in[0] = work_in[1] = 0;
		work_in[4] = work_in[5] = 0;
		work_in[2] = work_in[6] = (int)weite-1;
		work_in[3] = work_in[7] = (int)hoehe-1;
		/* Offset beim Zielraster nicht benutzt ?!? */
		work_in[4] = 0;
		work_in[5] = 0;
		work_in[6] = (int)weite-1;
		work_in[7] = (int)hoehe-1;

		/* Farbe fuer schwarze Quell-Pixel */
		color_index[0] = 1;
		/* Farbe fuer weisse Quell-Pixel */
		color_index[1] = 0;

		/* Bitmap auf (evtl. Farb-)Druckerseite kopieren (1 : REPLACE), *
		 * dabei wird auf dem Zielraster geclippt (laut Doku)!					*/
		vrt_cpyfm( hdl, 1, work_in, &bitmap, &drucker, color_index );

		/* drucken */
		v_updwk( hdl );
	}

	if(	 flag&4	 )
		v_form_adv( hdl );

	v_clswk( hdl );
	return 0;
}
/* Aenderungen 7.10.95 M. Pristovsek */
/* Korrektur und Bugkill 5.11.95 TW */
